Bug 1066342 - (CVE-2013-4151) CVE-2013-4151 qemu: virtio: out-of-bounds buffer write on invalid state load
CVE-2013-4151 qemu: virtio: out-of-bounds buffer write on invalid state load
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20131203,repor...
: Security
Depends On: 1095692 1095693 1095694 1095695 1096089 1102579 1102580 1110194 1110284 1110288 1133850
Blocks: 1036654 1110626 1133827
  Show dependency treegraph
 
Reported: 2014-02-18 04:27 EST by Petr Matousek
Modified: 2016-04-26 12:14 EDT (History)
45 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-09-22 07:23:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Petr Matousek 2014-02-18 04:27:01 EST
Michael S. Tsirkin writes:

QEMU 1.0 out-of-bounds buffer write in virtio_load@virtio/virtio.c

So we have this code since way back when:

    num = qemu_get_be32(f);

    for (i = 0; i < num; i++) {
        vdev->vq[i].vring.num = qemu_get_be32(f);

array of vqs has size VIRTIO_PCI_QUEUE_MAX, so
on invalid input this will write beyond end of buffer.

An user able to alter the savevm data (either on the disk or over the wire
during migration) could use this flaw to to corrupt QEMU process memory on
the (destination) host, which could potentially result in arbitrary code
execution on the host with the privileges of the QEMU process.

Upstream fix:
-------------
  -> http://git.qemu.org/?p=qemu.git;a=commit;h=cc45995294b92d95319b4782750a3580cabdbc0c
Comment 1 Petr Matousek 2014-02-18 06:09:20 EST
Statement:

This issue does affect the versions of kvm package as shipped with
Red Hat Enterprise Linux 5.

This issue does affect the versions of qemu-kvm package as shipped with
Red Hat Enterprise Linux 7.
Comment 4 Prasad J Pandit 2014-05-08 08:12:16 EDT
Created qemu tracking bugs for this issue:

Affects: fedora-all [bug 1095693]
Comment 6 Fedora Update System 2014-05-16 06:00:59 EDT
qemu-1.6.2-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 8 errata-xmlrpc 2014-06-09 10:36:40 EDT
This issue has been addressed in following products:

  RHEV-H and Agents for RHEL-6

Via RHSA-2014:0674 https://rhn.redhat.com/errata/RHSA-2014-0674.html
Comment 9 Murray McAllister 2014-06-10 03:39:54 EDT
Acknowledgements:

The issues were discovered as part of the state loading code audit performed by Michael S. Tsirkin of Red Hat, Anthony Liguori and Michael Roth.
Comment 10 errata-xmlrpc 2014-06-10 16:18:53 EDT
This issue has been addressed in following products:

  RHEV-H and Agents for RHEL-6

Via RHSA-2014:0744 https://rhn.redhat.com/errata/RHSA-2014-0744.html
Comment 11 errata-xmlrpc 2014-06-10 16:19:43 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2014:0743 https://rhn.redhat.com/errata/RHSA-2014-0743.html
Comment 15 errata-xmlrpc 2014-07-23 12:15:42 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 7

Via RHSA-2014:0927 https://rhn.redhat.com/errata/RHSA-2014-0927.html
Comment 17 errata-xmlrpc 2014-07-24 11:38:47 EDT
This issue has been addressed in following products:

  OpenStack 4 for RHEL 6
  OpenStack 3 for RHEL 6

Via RHSA-2014:0888 https://rhn.redhat.com/errata/RHSA-2014-0888.html
Comment 19 errata-xmlrpc 2014-09-22 00:01:11 EDT
This issue has been addressed in the following products:

  OpenStack 5 for RHEL 7

Via RHSA-2014:1268 https://rhn.redhat.com/errata/RHSA-2014-1268.html

Note You need to log in before you can comment on or make changes to this bug.